﻿using System;
using Microsoft.Win32;
using ComBaseClass;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length == 1)
            {
                if (args[0] == "/u")
                {
                    DeleteRegistry(@"Interface\{D7CE4B41-D2A5-3CCD-BF38-5B8197825E09}", Registry.ClassesRoot);
                    DeleteRegistry(@"Wow6432Node\Interface\{D7CE4B41-D2A5-3CCD-BF38-5B8197825E09}", Registry.ClassesRoot);

                    DeleteRegistry(@"Interface\{23172F2F-A3D3-4180-97AE-7805F74A5A46}", Registry.ClassesRoot);
                    DeleteRegistry(@"Wow6432Node\Interface\{23172F2F-A3D3-4180-97AE-7805F74A5A46}", Registry.ClassesRoot);

                    DeleteRegistry(@"TypeLib\{1CCE4407-4EA5-4A60-BAF8-809AB169CE4D}", Registry.ClassesRoot);
                    DeleteRegistry(@"Wow6432Node\TypeLib\{1CCE4407-4EA5-4A60-BAF8-809AB169CE4D}", Registry.ClassesRoot);

                    return;
                }

                if (args[0] == "/c")
                {
                    // 레지스트리 체크
                    Console.WriteLine("Check: ClassLibraryAsAdmin - CLSID, ProgId");
                    CheckRegistry("ClassLibraryAsAdmin.AdminCode", Registry.ClassesRoot);
                    CheckRegistry(@"CLSID\{41AC8568-9230-4E63-B7C5-CAAD997EE207}", Registry.ClassesRoot);
                    CheckRegistry(@"Wow6432Node\ClassLibraryAsAdmin.AdminCode", Registry.ClassesRoot);
                    CheckRegistry(@"Wow6432Node\CLSID\{41AC8568-9230-4E63-B7C5-CAAD997EE207}", Registry.ClassesRoot);
                    Console.WriteLine();

                    Console.WriteLine("Check: ClassLibraryAsAdmin - TypeLibrary");
                    CheckRegistry(@"TypeLib\{728F14FE-B021-43EF-8AAC-D37A4AF5ED6A}", Registry.ClassesRoot);
                    CheckRegistry(@"Wow6432Node\TypeLib\{728F14FE-B021-43EF-8AAC-D37A4AF5ED6A}", Registry.ClassesRoot);
                    Console.WriteLine();
                    
                    Console.WriteLine("Check: ComBaseClass - TypeLibrary");
                    CheckRegistry(@"TypeLib\{1CCE4407-4EA5-4A60-BAF8-809AB169CE4D}", Registry.ClassesRoot);
                    CheckRegistry(@"Wow6432Node\TypeLib\{1CCE4407-4EA5-4A60-BAF8-809AB169CE4D}", Registry.ClassesRoot);
                    Console.WriteLine();

                    Console.WriteLine("Check: ComBaseClass - Interface");
                    CheckRegistry(@"Interface\{23172F2F-A3D3-4180-97AE-7805F74A5A46}", Registry.ClassesRoot);
                    CheckRegistry(@"Wow6432Node\Interface\{23172F2F-A3D3-4180-97AE-7805F74A5A46}", Registry.ClassesRoot);
                    Console.WriteLine();

                    Console.WriteLine("Check: ClassLibraryAsAdmin - Interface");
                    CheckRegistry(@"Interface\{D7CE4B41-D2A5-3CCD-BF38-5B8197825E09}", Registry.ClassesRoot);
                    CheckRegistry(@"Wow6432Node\Interface\{D7CE4B41-D2A5-3CCD-BF38-5B8197825E09}", Registry.ClassesRoot);
                    Console.WriteLine();
                    return;
                }
            }

            //AdminCode ad = new AdminCode();
            //ad.SetRegistryValue();

            Console.WriteLine("CLSID C# DLL Test: ");

            // CLSID 로 COM 개체 생성
            try
            {
                Guid guid = new Guid("{41AC8568-9230-4E63-B7C5-CAAD997EE207}");
                Type type = Type.GetTypeFromCLSID(guid);
                ActivateInstance(type);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            Console.WriteLine("ProgId C# DLL Test: ");

            // ProgId 로 COM 개체 생성
            try
            {
                Type type = Type.GetTypeFromProgID("ClassLibraryAsAdmin.AdminCode");
                ActivateInstance(type);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            Console.WriteLine("Press any key to exit...!!!");
            Console.ReadLine();
        }

        private static void DeleteRegistry(string regPath, RegistryKey registryKey)
        {
            try
            {
                registryKey.DeleteSubKeyTree(regPath);
            }
            catch (Exception ex)
            {
                Console.WriteLine(regPath + ": " + ex.ToString());
            }
        }

        private static void ActivateInstance(Type type)
        {
            object comObject = Activator.CreateInstance(type);
            Console.WriteLine(comObject);
            IAdminCode adminCode = comObject as IAdminCode;
            adminCode.SetRegistryValue();
            adminCode.TestMethod();
            adminCode.TestMethod2();
        }

        private static void CheckRegistry(string regPath, RegistryKey registryKey)
        {
            using (RegistryKey regKey = registryKey.OpenSubKey(regPath))
            {
                Console.WriteLine("Exists: " + regPath + ": " + (regKey != null));
            }
        }
    }
}
